
;***************************     400 - 450   ****************     
;***************************  Checksum  02fd7   *******************************

	list     p=pic16f628a

	include  P16f628a.inc
    
    __CONFIG   3f14h
 
	errorlevel +207

 cblock  0x20
coun
coun1
coun_digit
Ch_lo                             ;      
Ch_hi                             ;      
Ch_start_lo                       ;     
Ch_start_hi                       ;     
Ch_end_lo                         ;     
Ch_end_hi                         ;     
Ch_TEMP
Ch_TEMP_W
W_TEMP
ST_TEMP
TMR_flags
LCD_TEMP
EEPROM_TEMP
REG_Noise
aar0                              ;     
aar1                              ;     
aac0                              
aac1 
aac2 
aac3 
aac4 
CCPR1L_W
aar0_W
aar1_W
ACCaLO
ACCbLO
ACCbHI
ACCaHI                 
 endc           
                                    
#define bank0    bcf STATUS,RP0       
#define bank1    bsf STATUS,RP0

        ORG      0h                   
        goto     Init 
;******************************************************************************* 
;************       **************************************
        ORG      4h              ;    
        movwf   W_TEMP           ;  W   - 
        movf    STATUS,W         ;  STATUS  W 
        movwf   ST_TEMP          ;  W   - 
;**********************
        bcf     INTCON,2         ;    TMR0
        movlw   .238             ; 10.5 kHz
        movwf   TMR0            
        comf    TMR_flags
        bcf     PORTA,3
        btfsc   TMR_flags,0
        bsf     PORTA,3
        CLRWDT
;**********************
        movf    ST_TEMP,W        ;     STATUS 
        movwf   STATUS           ;  W
        swapf   W_TEMP,f
        swapf   W_TEMP,W
        retfie                   ;    GIE   1 
;*******************************************************************************
;************      ************************************************                           			
Init    bank1 
        movlw    .255           
        movwf    PR2^80H         ;   
        movlw    b'00100110'           
        movwf    TRISA
        movlw    b'01000111'
        movwf    TRISB
	    clrf	 OPTION_REG^80H ;    
        movlw    b'10100000'
        movwf	 INTCON	    	;    TMR0
        bank0
        clrf     PIR1           ;    
        movlw    .255
        movwf    CCPR1L         ;   
        movlw    b'00001100'    
        movwf    CCP1CON        ;   
        movlw    b'00000100'
        movwf    T2CON          ;   2
        clrf     TMR2           ;  TMR2
        movlw    b'00000101'
	    movwf	 CMCON			;   
        clrf     PORTA  
        clrf     PORTB
;*******************************************************************************
;*******************************************************************************
        nop                     ;                
;*******************************************************************************
;***********        *******************************************
;*******************************************************************************
        call     Ch_start       
        call     Ch_end
        clrf     REG_Noise
FUNC_0  btfss    PORTB,2        ;  FUNC
        goto     FUNC_0         ;   
        clrf     Ch_TEMP
        call     Convert
        call     LOAD_ind
BEGIN   call     Noise
        btfss    PORTA,5 ;(+)
        call     CH_up
        btfss    PORTB,1 ;(-)
        call     CH_down
        btfss    PORTB,2        ;  FUNC
        goto     FUNC_1 
        goto     BEGIN
;*******************************************************************************
;*******************************************************************************
;*******************************************************************************
TABL_digit
        btfsc    Ch_lo,0        ;     
        addlw    .8             ;     
                                ;        
        addwf  PCL,f
        retlw  b'10100000';.0 ;0
        retlw  b'00010000';.0 ;1
        retlw  b'00100000';.0 ;2
        retlw  b'00100000';.0 ;3
        retlw  b'00110000';.0 ;4
        retlw  b'00110000';.0 ;5 
        retlw  b'01000000';.0 ;6 
        retlw  b'01000000';.0 ;7 
        retlw  b'01010000';.0 ;8
        retlw  b'01010000';.0 ;9 
        retlw  b'01100000';.0 ;10 
        retlw  b'01100000';.0 ;11 
        retlw  b'01110000';.0 ;12 
        retlw  b'01110000';.0 ;13 
        retlw  b'10000000';.0 ;14  
        retlw  b'10000000';.0 ;15 
        retlw  b'10010000';.0 ;16
        retlw  b'10100001';.1 ;17
        retlw  b'00010001';.1 ;18
        retlw  b'00100001';.1 ;19
        retlw  b'00100001';.1 ;20
        retlw  b'00110001';.1 ;21
        retlw  b'00110001';.1 ;22 
        retlw  b'01000001';.1 ;23 
        retlw  b'01000001';.1 ;24 
        retlw  b'01010001';.1 ;25
        retlw  b'01010001';.1 ;26 
        retlw  b'01100001';.1 ;27 
        retlw  b'01100001';.1 ;28 
        retlw  b'01110001';.1 ;29 
        retlw  b'01110001';.1 ;30 
        retlw  b'10000001';.1 ;31  
        retlw  b'10000001';.1 ;32 
        retlw  b'10010001';.1 ;33
        retlw  b'10100010';.2 ;34
        retlw  b'00010010';.2 ;35
        retlw  b'00100010';.2 ;36
        retlw  b'00100010';.2 ;37
        retlw  b'00110010';.2 ;38
        retlw  b'00110010';.2 ;39 
        retlw  b'01000010';.2 ;40 
        retlw  b'01000010';.2 ;41 
        retlw  b'01010010';.2 ;42
        retlw  b'01010010';.2 ;43 
        retlw  b'01100010';.2 ;44 
        retlw  b'01100010';.2 ;45 
        retlw  b'01110010';.2 ;46 
        retlw  b'01110010';.2 ;47 
        retlw  b'10000010';.2 ;48  
        retlw  b'10000010';.2 ;49 
        retlw  b'10010010';.2 ;50
        retlw  b'10100011';.3 ;51
        retlw  b'00010011';.3 ;52
        retlw  b'00100011';.3 ;53
        retlw  b'00100011';.3 ;54
        retlw  b'00110011';.3 ;55
        retlw  b'00110011';.3 ;56 
        retlw  b'01000011';.3 ;57 
        retlw  b'01000011';.3 ;58 
        retlw  b'01010011';.3 ;59
        retlw  b'01010011';.3 ;60 
        retlw  b'01100011';.3 ;61 
        retlw  b'01100011';.3 ;62 
        retlw  b'01110011';.3 ;63 
        retlw  b'01110011';.3 ;64 
        retlw  b'10000011';.3 ;65  
        retlw  b'10000011';.3 ;66 
        retlw  b'10010011';.3 ;67
        retlw  b'10100100';.4 ;68
        retlw  b'00010100';.4 ;69
        retlw  b'00100100';.4 ;70
        retlw  b'00100100';.4 ;71
        retlw  b'00110100';.4 ;72
        retlw  b'00110100';.4 ;73 
        retlw  b'01000100';.4 ;74 
        retlw  b'01000100';.4 ;75 
        retlw  b'01010100';.4 ;76
        retlw  b'01010100';.4 ;77 
        retlw  b'01100100';.4 ;78 
        retlw  b'01100100';.4 ;79 
        retlw  b'01110100';.4 ;80 
        retlw  b'01110100';.4 ;81 
        retlw  b'10000100';.4 ;82  
        retlw  b'10000100';.4 ;83 
        retlw  b'10010100';.4 ;84
        retlw  b'10100101';.5 ;85
        retlw  b'00010101';.5 ;86
        retlw  b'00100101';.5 ;87
        retlw  b'00100101';.5 ;88
        retlw  b'00110101';.5 ;89
        retlw  b'00110101';.5 ;90 
        retlw  b'01000101';.5 ;91 
        retlw  b'01000101';.5 ;92 
        retlw  b'01010101';.5 ;93
        retlw  b'01010101';.5 ;94 
        retlw  b'01100101';.5 ;95 
        retlw  b'01100101';.5 ;96 
        retlw  b'01110101';.5 ;97 
        retlw  b'01110101';.5 ;98 
        retlw  b'10000101';.5 ;99  
        retlw  b'10000101';.5 ;100 
        retlw  b'10010101';.5 ;101
        retlw  b'10100110';.6 ;102
        retlw  b'00010110';.6 ;103
        retlw  b'00100110';.6 ;104
        retlw  b'00100110';.6 ;105
        retlw  b'00110110';.6 ;106
        retlw  b'00110110';.6 ;107 
        retlw  b'01000110';.6 ;108 
        retlw  b'01000110';.6 ;109 
        retlw  b'01010110';.6 ;110
        retlw  b'01010110';.6 ;111 
        retlw  b'01100110';.6 ;112 
        retlw  b'01100110';.6 ;113 
        retlw  b'01110110';.6 ;114 
        retlw  b'01110110';.6 ;115 
        retlw  b'10000110';.6 ;116  
        retlw  b'10000110';.6 ;117 
        retlw  b'10010110';.6 ;118
        retlw  b'10100111';.7 ;119 
        retlw  b'00010111';.7 ;120 
        retlw  b'00100111';.7 ;121
        retlw  b'00100111';.7 ;122
        retlw  b'00110111';.7 ;123 
        retlw  b'00110111';.7 ;124 
        retlw  b'01000111';.7 ;125
        retlw  b'01000111';.7 ;126
        retlw  b'01010111';.7 ;127 
        retlw  b'01010111';.7 ;119 
        retlw  b'01100111';.7 ;120 
        retlw  b'01100111';.7 ;121
        retlw  b'01110111';.7 ;122
        retlw  b'01110111';.7 ;123 
        retlw  b'10000111';.7 ;124 
        retlw  b'10000111';.7 ;125
        retlw  b'10010111';.7 ;126
        retlw  b'10010111';.7 ;127 
;*******************************************************************************
;***********           *************************
TABL_digit_del
        swapf    coun_digit,f
        bcf      coun_digit,7            ;    
        bcf      coun_digit,6
        bcf      coun_digit,5
        bcf      coun_digit,4
        movf     coun_digit,W
        addwf  PCL,f
        return              ;0
        goto    M_digit_del ;1
        return              ;2
        return              ;3
        return              ;4
        return              ;5 
        return              ;6 
        return              ;7 
        return              ;8
        goto    M_digit_del ;9 
        goto    M_digit_del ;10 
M_digit_del
        call    digit_del
        return
;***********   FUNC_1  *********************************************************
;*******************************************************************************
FUNC_1  btfss    PORTB,6        ;   FUNC_MEMORY
        goto     FUNC_1         ;   
        btfss    PORTB,2        ;  FUNC
        goto     FUNC_1         ;    
        clrf     Ch_TEMP
        call     Convert
        call     LOAD_ind
m_f_1   call     Noise
        btfss    PORTA,5 ;(+)
        call     Fine_tuning_up
        btfss    PORTB,1 ;(-)
        call     Fine_tuning_down
        btfss    PORTB,6        ;   FUNC_MEMORY
        call     FUNC_MEMORY
        btfss    PORTB,2        ;  FUNC
        goto     FUNC_2              
        goto     m_f_1
;***********   FUNC_MEMORY  ****************************************************
;*******************************************************************************
FUNC_MEMORY
        clrf     Ch_TEMP        ;      
        btfss    PORTB,6        ;   FUNC_MEMORY 
        goto     FUNC_MEMORY    ;   
        call     Convert
        call     LOAD_ind
F_m_0   call     Noise
        btfss    PORTA,5 ;(+)
        call     Mem_up
        btfss    PORTB,1 ;(-)
        call     Mem_down
        btfss    PORTB,6        ;   FUNC_MEMORY 
        goto     F_m_1       
        goto     F_m_0
F_m_1   call     WR_Ch          ;             
        clrf     Ch_TEMP 
        call     Convert
        call     LOAD_ind
        call     delay
        goto     FUNC_1 
;***********   FUNC_2  *********************************************************
;******************************************************************************* 
FUNC_2  btfss    PORTB,2        ;  FUNC
        goto     FUNC_2         ;   
        clrf     Ch_TEMP 
m_f_2   call     Noise
        btfss    PORTA,5 ;(+)
        call     Ch_reed_up
        btfss    PORTB,1 ;(-)
        call     Ch_reed_down
        btfss    PORTB,2        ;  FUNC
        goto     FUNC_0         ;     
        goto     m_f_2
;*******************************************************************************
;***********       *************************************
CH_up   call     stop_tuning_up
        btfsc    STATUS,Z
        return
        clrf     CCPR1L                  ;    
        comf     CCPR1L,f
        bcf      STATUS,Z
        comf     Ch_lo,W
        btfsc    STATUS,Z
        incf     Ch_hi,f
        incf     Ch_lo,f
        call     Load_sunt
        call     Convert
        call     LOAD_ind
        call     delay
        return
;*******************************************************************************
;***********       **************************************
CH_down call     stop_tuning_down 
        btfsc    STATUS,Z
        return
        clrf     CCPR1L                  ;    
        comf     CCPR1L,f
        bcf      STATUS,Z
        movf     Ch_lo,f
        btfsc    STATUS,Z
        decf     Ch_hi,f
        decf     Ch_lo,f
        call     Load_sunt
        call     Convert
        call     LOAD_ind
        call     delay
        return
;*******************************************************************************
;***********       ****************************************
Fine_tuning_up
        call     stop_tuning_up
        btfsc    STATUS,Z
        return
        bcf      STATUS,Z
        movf     CCPR1L,W
        btfsc    STATUS,Z
        goto     M_ch_up
        decf     CCPR1L,f
        call     Convert
        call     LOAD_ind
        call     delay
        call     TABL_digit_del
        return
M_ch_up clrf     CCPR1L                  ;    
        comf     CCPR1L,f                ;     
        bcf      STATUS,Z
        comf     Ch_lo,W
        btfsc    STATUS,Z
        incf     Ch_hi,f
        incf     Ch_lo,f
        call     Load_sunt
        call     Convert
        call     LOAD_ind
        call     TABL_digit_del
        return       
;*******************************************************************************
;***********       *****************************************
Fine_tuning_down
        bcf      STATUS,Z
        comf     CCPR1L,W
        btfsc    STATUS,Z
        goto     M_ch_down
        incf     CCPR1L,f
        call     Convert
        call     LOAD_ind
        call     delay
        call     TABL_digit_del
        return
M_ch_down
        call     stop_tuning_down        
        btfsc    STATUS,Z
        return
        clrf     CCPR1L                  ;    
        bcf      STATUS,Z                ;     
        movf     Ch_lo,f
        btfsc    STATUS,Z
        decf     Ch_hi,f
        decf     Ch_lo,f
        call     Load_sunt
        call     Convert
        call     LOAD_ind 
        call     TABL_digit_del
        return
;*******************************************************************************
;***********   Mem_up  *********************************************************  
Mem_up  movlw    .10            ;   10  Ch_TEMP
        subwf    Ch_TEMP,W 
        btfsc    STATUS,C
        return
        incf     Ch_TEMP,f
        call     Convert
        call     LOAD_ind
m_m_up  btfss    PORTA,5        ;   ( + ) 
        goto     m_m_up         ;   
        call     delay
        return 
;*******************************************************************************
;***********   Mem_down  *******************************************************
Mem_down
        movlw    .2             ;   1  Ch_TEMP
        subwf    Ch_TEMP,W 
        btfss    STATUS,C
        return
        decf     Ch_TEMP,f
        call     Convert
        call     LOAD_ind
m_m_down
        btfss    PORTB,1        ;   ( - ) 
        goto     m_m_down      ;   
        call     delay
        return
;*******************************************************************************
;***********       *********************************
Ch_reed_up 
        movlw    .10            ;   10  Ch_TEMP
        subwf    Ch_TEMP,W 
        btfsc    STATUS,C
        return
        incf     Ch_TEMP,f
        call     REED_Ch
m_r_up  btfss    PORTA,5        ;   ( + ) 
        goto     m_r_up         ;   
        call     delay
        return 
;*******************************************************************************
;***********       *********************************
Ch_reed_down 
        movlw    .2             ;   1  Ch_TEMP
        subwf    Ch_TEMP,W 
        btfss    STATUS,C
        return
        decf     Ch_TEMP,f
        call     REED_Ch
m_r_down
        btfss    PORTB,1        ;   ( - ) 
        goto     m_r_down       ;   
        call     delay
        return
;*******************************************************************************                                                
;***********     *************************************************
Noise   call     Noise_on_off
        call     Noise_filter
        return
Noise_on_off
        btfsc    PORTB,0        ;    
        return
        comf     REG_Noise
m_on_off
        call     Noise_filter
        btfss    PORTB,0        ;   
        goto     m_on_off
        call     delay          ; 
        return
Noise_filter
        btfss    REG_Noise,0
        goto     m_filter
        btfsc    CMCON,7        
        bsf      PORTA,0        ;  
        btfss    CMCON,7        
        bcf      PORTA,0        ;   
        return
m_filter   
        bcf      PORTA,0        ;  
        return                 
;*******************************************************************************
;***********   LOAD 0 (  ) *******************************************
LOAD_0  call   del_5ms 
        bsf    PORTB,7          ; CE=1  
        bcf    PORTA,7          ; DATA=0
        call   del_5ms 
        bsf    PORTA,6          ; CLC=1
        call   del_5ms 
        bcf    PORTA,6          ; CLC=0
        call   del_5ms 
        return
;*******************************************************************************
;***********   LOAD 1 (  ) *******************************************
LOAD_1  call   del_5ms  
        bsf    PORTB,7          ; CE=1  
        bsf    PORTA,7          ; DATA=1
        call   del_5ms 
        bsf    PORTA,6          ; CLC=1
        call   del_5ms 
        bcf    PORTA,6          ; CLC=0
        call   del_5ms 
        return     
;******************************************************************************* 
;***********          *************************
Load_sunt
        btfsc    Ch_lo,0        
        call     LOAD_1
        btfss    Ch_lo,0 
        call     LOAD_0
      
        btfsc    Ch_lo,1        
        call     LOAD_1
        btfss    Ch_lo,1 
        call     LOAD_0

        btfsc    Ch_lo,2        
        call     LOAD_1
        btfss    Ch_lo,2 
        call     LOAD_0

        btfsc    Ch_lo,3        
        call     LOAD_1
        btfss    Ch_lo,3 
        call     LOAD_0

        btfsc    Ch_lo,4        
        call     LOAD_1
        btfss    Ch_lo,4 
        call     LOAD_0
      
        btfsc    Ch_lo,5        
        call     LOAD_1
        btfss    Ch_lo,5 
        call     LOAD_0

        btfsc    Ch_lo,6        
        call     LOAD_1
        btfss    Ch_lo,6 
        call     LOAD_0

        btfsc    Ch_lo,7        
        call     LOAD_1
        btfss    Ch_lo,7 
        call     LOAD_0

;**************

        btfsc    Ch_hi,0        
        call     LOAD_1
        btfss    Ch_hi,0 
        call     LOAD_0
      
        btfsc    Ch_hi,1        
        call     LOAD_1
        btfss    Ch_hi,1 
        call     LOAD_0

        btfsc    Ch_hi,2        
        call     LOAD_1
        btfss    Ch_hi,2 
        call     LOAD_0

        btfsc    Ch_hi,3        
        call     LOAD_1
        btfss    Ch_hi,3 
        call     LOAD_0

        btfsc    Ch_hi,4        
        call     LOAD_1
        btfss    Ch_hi,4
        call     LOAD_0
      
        btfsc    Ch_hi,5        
        call     LOAD_1
        btfss    Ch_hi,5 
        call     LOAD_0

        btfsc    Ch_hi,6        
        call     LOAD_1
        btfss    Ch_hi,6 
        call     LOAD_0

        btfsc    Ch_hi,7        
        call     LOAD_1
        btfss    Ch_hi,7 
        call     LOAD_0
;**************
        call     LOAD_0           
        call     LOAD_0 
        call     LOAD_0 
        call     LOAD_0
        call     LOAD_0
        call     LOAD_1 
        call     LOAD_0        
        call     LOAD_1
;**************
        bcf      PORTA,6
        bcf      PORTB,7   
        bcf      PORTA,7  
        return                           
;*******************************************************************************
;***********          **************
Convert
 
 movf    Ch_lo,W             ;     W   
 movwf   aar0 
 
 movf    Ch_hi,W             ;     W  
 movwf   aar1

;***********
                             ;   10 
         movf  aar0,W 
         movwf ACCaLO
         movf  aar1,W 
         movwf ACCaHI

         movf  aar0,W 
         movwf ACCbLO
         movf  aar1,W 
         movwf ACCbHI

         call  D_add  
         call  D_add 
         call  D_add 
         call  D_add  
         call  D_add 
         call  D_add 
         call  D_add  
         call  D_add 
         call  D_add 

         movf   ACCbLO,W	 
         movwf  aar0 
         movf   ACCbHI,W	 
         movwf  aar1 

;***********

 bcf     STATUS,C            ;   2 
 rrf     aar1,f 
 rrf     aar0,f

 bcf     STATUS,C            ;   2 
 rrf     aar1,f 
 rrf     aar0,f

;***********
                             ;   3 
         movf  aar0,W 
         movwf ACCaLO
         movf  aar1,W 
         movwf ACCaHI

         movf  aar0,W 
         movwf ACCbLO
         movf  aar1,W 
         movwf ACCbHI

         call  D_add  
         call  D_add 

         movf   ACCbLO,W	 
         movwf  aar0 
         movf   ACCbHI,W	 
         movwf  aar1 

;***********         
                              ; +  21,4
         movf  aar0,W 
         movwf ACCaLO
         movf  aar1,W 
         movwf ACCaHI

         movlw b'01011100' 
         movwf ACCbLO
         movlw b'00001000'
         movwf ACCbHI

         call  D_add  

         movf   ACCbLO,W	 
         movwf  aar0 
         movf   ACCbHI,W	 
         movwf  aar1 

;***********

         comf     CCPR1L,W          ;     
         movwf    CCPR1L_W          ;  

         bcf      STATUS,C
         rrf      CCPR1L_W,W        ;   2

         call     TABL_digit        ;     
                                    ;  
         movwf    CCPR1L_W
         movwf    coun_digit
         bcf      CCPR1L_W,7
         bcf      CCPR1L_W,6
         bcf      CCPR1L_W,5
         bcf      CCPR1L_W,4

         btfsc    Ch_lo,0           ;   (    )  
         incf     CCPR1L_W,f        ;  ,    

         movf   aar0,W 
         movwf  ACCaLO
         movf   aar1,W 
         movwf  ACCaHI

         movf   CCPR1L_W,W
         movwf  ACCbLO
         movlw  b'00000000'
         movwf  ACCbHI

         call   D_add  

         movf   ACCbLO,W	 
         movwf  aar0 
         movf   ACCbHI,W	 
         movwf  aar1 

;***********
;aar0 =    
;aar1 =    

;aac0 = 
;aac1 = 
;aac2 = 
;aac3 = 
;aac4 =   
;***********                                5   
;                                          
b16_d5
        swapf   aar0,w
        addwf   aar0,w
        andlw   0x0f
        skpndc
        addlw   0x16
        skpndc
        addlw   0x06
        addlw   0x06
        skpdc
        addlw  -0x06
        btfsc   aar0,4
        addlw   0x15+0x06
        skpdc 
        addlw  -0x06
        movwf   aac0
        swapf   aar1,w
        addwf   aar1,w
        andlw   0x0f
        skpndc
        addlw   0x16
        skpndc
        addlw   0x06
        addlw   0x06
        skpdc
        addlw  -0x06
        btfsc   aar1,0
        addlw   0x05+0x06
        skpdc 
        addlw  -0x06
        btfsc   aar1,4
        addlw   0x15+0x06
        skpdc 
        addlw  -0x06
        addlw   0x06
        addwf   aac0,w
        skpdc 
        addlw   -0x06
        movwf   aac0
        movwf   aac1
        swapf   aac1,f
        movlw   0x0f
        andwf   aac0,f
        andwf   aac1,f
        rrf     aar1,w
        andlw   0x0f
        addlw   0x06
        skpdc
        addlw  -0x06
        addlw   0x06
        addwf   aac1,w
        skpdc 
        addlw  -0x06
        btfsc   aar0,5
        addlw   0x03+0x06
        skpdc 
        addlw  -0x06
        btfsc   aar0,6
        addlw   0x06+0x06
        skpdc 
        addlw  -0x06
        btfsc   aar0,7
        addlw   0x12+0x06
        skpdc 
        addlw  -0x06
        btfsc   aar1,0
        addlw   0x25+0x06
        skpdc 
        addlw  -0x06
        btfsc   aar1,5
        addlw   0x09+0x06
        skpdc 
        addlw  -0x06
        btfsc   aar1,6
        addlw   0x08+0x06
        skpdc 
        addlw  -0x06
        btfsc   aar1,7
        addlw   0x06+0x06
        skpdc 
        addlw  -0x06
        movwf   aac1
        swapf   aac1,w
        andlw   0x0f
        btfsc   aar1,1
        addlw   0x05+0x06
        skpdc 
        addlw  -0x06
        btfsc   aar1,5
        addlw   0x01+0x06
        skpdc 
        addlw  -0x06
        btfsc   aar1,6
        addlw   0x03+0x06
        skpdc 
        addlw  -0x06
        btfsc   aar1,7
        addlw   0x07+0x06
        skpdc 
        addlw  -0x06
        movwf   aac2
        swapf   aac2,w
        movwf   aac3
        movlw   0x0f
        andwf   aac1,f
        andwf   aac2,f
        andwf   aac3,f
        rrf     aar1,w
        movwf   aac4
        rrf     aac4,w
        andlw   0x0f
        addlw   0x06
        skpdc
        addlw  -0x06
        addlw   0x06
        addwf   aac3,w
        skpdc
        addlw-0x06
        btfsc   aar1,6
        addlw   0x16+0x06
        skpdc
        addlw  -0x06
        btfsc   aar1,7
        addlw   0x32+0x06
        skpdc
        addlw  -0x06
        movwf   aac3
        movwf   aac4
        swapf   aac4,f
        movlw   0x0f
        andwf   aac3,f
        andwf   aac4,f

;***********************
        movlw   .10
        
        bcf     STATUS,Z        ;  ,  0   
        movf    aac0,f          ; aac4   (   )
        btfsc   STATUS,Z
        movwf   aac0

        bcf     STATUS,Z
        movf    aac1,f
        btfsc   STATUS,Z
        movwf   aac1

        bcf     STATUS,Z
        movf    aac2,f
        btfsc   STATUS,Z
        movwf   aac2

        bcf     STATUS,Z
        movf    aac3,f
        btfsc   STATUS,Z
        movwf   aac3
;***********************

        return       
;*******************************************************************************
;***********       **************************************
LOAD_ind
        clrf     LCD_TEMP
        call     LOAD_digit

        clrf     LCD_TEMP
        call     LOAD_digit

        movf     aac4,W
        movwf    LCD_TEMP
        call     LOAD_digit

        movf     aac3,W
        movwf    LCD_TEMP
        call     LOAD_digit

        movf     aac2,W
        movwf    LCD_TEMP
        call     LOAD_digit

        movf     aac1,W
        movwf    LCD_TEMP
        call     LOAD_digit

        movf     aac0,W
        movwf    LCD_TEMP
        call     LOAD_digit

        swapf    coun_digit,W     
        movwf    LCD_TEMP
        call     LOAD_digit

        clrf     LCD_TEMP
        call     LOAD_digit

        movf     Ch_TEMP,W
        movwf    LCD_TEMP
        call     LOAD_digit 

        return
;*******************************************************************************
;***********         ***********************************
LOAD_digit
        btfsc    LCD_TEMP,3
        bsf      PORTB,4
        call     STROB_LCD

        btfsc    LCD_TEMP,2
        bsf      PORTB,4
        call     STROB_LCD

        btfsc    LCD_TEMP,1
        bsf      PORTB,4
        call     STROB_LCD

        btfsc    LCD_TEMP,0
        bsf      PORTB,4
        call     STROB_LCD

        return
;*******************************************************************************
;***********       *******************************************
STROB_LCD 
        bsf     PORTB,5
        nop
        nop
        nop
        nop
        nop
        nop
        bcf     PORTB,5
        nop
        nop
        nop
        nop
        nop
        nop
        bcf     PORTB,4
        nop
        nop
        nop
        nop
        nop
        nop
        return
;*******************************************************************************
;***********    /      ************
D_sub   call   neg_A   		
D_add 	movf   ACCaLO,W
   	    movf   ACCaLO,W	 	
        addwf  ACCbLO,F	 	
 	    btfsc  STATUS,C		
 	    incf   ACCbHI,F	 	
 	    movf   ACCaHI,W	 	
 	    addwf  ACCbHI,F	 	
 	    retlw  0
neg_A   comf   ACCaLO,F
	    comf   ACCaLO,F		
 	    incf   ACCaLO,F	 	
 	    btfsc  STATUS,Z	 	
 	    decf   ACCaHI,F	 	
 	    comf   ACCaHI,F	 	
 	    retlw  0
;*******************************************************************************
;***********      ROM    ***********************************
EEPROM_READ 
        clrf   INTCON             ;   
        CLRWDT 
        bank1
        movwf  EEADR              
	    bsf    EECON1,RD          ;  
	    movf   EEDATA,W           ;   W   
        bank0  
        movwf   W_TEMP 
        movlw  b'10100000'
        movwf  INTCON	          ;    TMR0                          
        movf   W_TEMP,W 
        return
;*******************************************************************************
;***********         ************************************
stop_tuning_up 
        movf   Ch_lo,W            ;   W Ch_lo
        bcf    STATUS,Z	
        subwf  Ch_end_lo,W        ; Ch_end_lo - W
        btfss  STATUS,Z     
        return
        movf   Ch_hi,W            ;   W Ch_hi
        bcf    STATUS,Z	
        subwf  Ch_end_hi,W        ; Ch_end_hi - W                                
        return
;*******************************************************************************
;***********         *************************************
stop_tuning_down 
        movf   Ch_lo,W            ;   W Ch_lo
        bcf    STATUS,Z	
        subwf  Ch_start_lo,W      ; Ch_start_lo - W
        btfss  STATUS,Z     
        return
        movf   Ch_hi,W            ;   W Ch_hi
        bcf    STATUS,Z	
        subwf  Ch_start_hi,W      ; Ch_end_hi - W                                
        return                        
;*******************************************************************************
;***********             **************
Ch_start
         movlw  .0           ;  W    
         call   EEPROM_READ  
                             ;    W      
         
;***********
                             ;   10    W 
         movwf ACCaLO 
         movwf ACCbLO
         clrf  ACCaHI
         clrf  ACCbHI

         movlw  .9
         movwf coun
m_Ch_start
         call  D_add 
       decfsz  coun,f
         goto  m_Ch_start

         movf   ACCbLO,W	 
         movwf  Ch_start_lo
         movf   ACCbHI,W	 
         movwf  Ch_start_hi 

;***********

 bcf     STATUS,C            ;   2 
 rlf     Ch_start_lo,f
 rlf     Ch_start_hi,f

 bcf     STATUS,C            ;   2 
 rlf     Ch_start_lo,f
 rlf     Ch_start_hi,f

;***********

        movf     Ch_start_lo,W        
        movwf    Ch_lo

        movf     Ch_start_hi,W        
        movwf    Ch_hi

;***********
        call     delay_lo
        call     delay_lo
        call     delay_lo

        clrf     Ch_TEMP
        call     Load_sunt 
        call     Convert
        call     LOAD_ind

;***********
 
        return
;*******************************************************************************
;***********             ***********
Ch_end
         movlw  .1           ;  W    
         call   EEPROM_READ  
                             ;    W              
;***********
                             ;   10    W 
         movwf ACCaLO 
         movwf ACCbLO
         clrf  ACCaHI
         clrf  ACCbHI

         movlw  .9
         movwf coun
m_Ch_end
         call  D_add 
       decfsz  coun,f
         goto  m_Ch_end 

         movf   ACCbLO,W	 
         movwf  Ch_end_lo
         movf   ACCbHI,W	 
         movwf  Ch_end_hi

;***********

 bcf     STATUS,C            ;   2 
 rlf     Ch_end_lo,f
 rlf     Ch_end_hi,f

 bcf     STATUS,C            ;   2 
 rlf     Ch_end_lo,f
 rlf     Ch_end_hi,f

;***********
 
        return
;*******************************************************************************
;***********               ****************************
EEPROM_WRITE
        CLRWDT
        clrf   INTCON        ;   
        bank1
        movwf  EEADR         ;  W     EEADR 
        bank0 
        movf   EEPROM_TEMP,W ;      EEPROM_TEMP
        bank1 
        movwf  EEDATA        ;  EEDATA
        bsf	   EECON1,WREN	 ;    PROM 
        call   ee_wr
        movlw  b'10100000'
        movwf  INTCON	     ;    TMR0
        bank0
        return
;*******************************************************************************
;*******************************************************************************                          
 ee_wr  CLRWDT
     	movlw  55H            		 
	    movwf  EECON2		       
    	movlw  0AAH			        
    	movwf  EECON2		        
    	bsf	   EECON1,WR	       
ee_wr1	CLRWDT
        btfsc  EECON1,WR		    
	    goto   ee_wr1			  
        bcf    EECON1,WREN		                              
    	return
;*******************************************************************************
;***********               ****************************
WR_Ch   bcf    STATUS,Z
        movf   Ch_TEMP,W
        btfsc  STATUS,Z
        return                ;   Ch_TEMP 0 ,  
        addwf  Ch_TEMP,f       
        addwf  Ch_TEMP,f      ; Ch_TEMP   3
        movf   Ch_lo,W        ;      
        movwf  EEPROM_TEMP
        movf   Ch_TEMP,W      ;     
        call   EEPROM_WRITE   ;  
        movf   Ch_hi,W  
        movwf  EEPROM_TEMP
        movf   Ch_TEMP,W
        addlw  .1             ;            
        call   EEPROM_WRITE   
        movf   CCPR1L,W  
        movwf  EEPROM_TEMP
        movf   Ch_TEMP,W 
        addlw  .2             ;                
        call   EEPROM_WRITE   
        return
;*******************************************************************************
;***********              ****************************
REED_Ch movf   Ch_TEMP,W
        movwf  Ch_TEMP_W      ;  Ch_TEMP  
        addwf  Ch_TEMP,f       
        addwf  Ch_TEMP,f      ; Ch_TEMP   3
        movf   Ch_TEMP,W      ;  W    
        call   EEPROM_READ 
        movwf  Ch_lo
        movf   Ch_TEMP,W 
        addlw  .1             ;                
        call   EEPROM_READ 
        movwf  Ch_hi
        movf   Ch_TEMP,W 
        addlw  .2             ;     
        call   EEPROM_READ
        movwf  CCPR1L
        movf   Ch_TEMP_W,W
        movwf  Ch_TEMP        ;  Ch_TEMP  
        call   Load_sunt
        call   Convert
        call   LOAD_ind
        return 
;******************************************************************************* 
;***********     *******************************************************  
del_5ms movlw   .9
        movwf   coun1  
loop2s  movlw   .10      
        movwf   coun      
loop1s  decfsz  coun,f
        goto    loop1s
        decfsz  coun1,f
        goto    loop2s
        return           
;******************************************************************************* 
;***********     *******************************************************     
delay   movlw   .100
        movwf   coun1  
loop2a  movlw   .100       
        movwf   coun        
loop1a  decfsz  coun,f
        goto    loop1a
        decfsz  coun1,f
        goto    loop2a
        return           
;******************************************************************************* 
;***********     *******************************************************
digit_del   
        movlw   .104
        movwf   coun1 
loop2x  movlw   .100       
        movwf   coun        
loop1x  decfsz  coun,f
        goto    loop1x
        decfsz  coun1,f
        goto    loop2x
        return 
;******************************************************************************* 
;***********     ******************************************************* 
delay_lo
        clrf   TMR1L             ;       
        clrf   TMR1H             ;       
        movlw  b'00110001'       ;     
        movwf  T1CON 
        bcf    PIR1,0            ;              
m_lo    btfss  PIR1,0
        goto   m_lo 
        clrf   T1CON             ;  
        return                            
;******************************************************************************* 
;*******************************************************************************
 ORG	0x2100
		DE .132, .142       
        end



